"""
------------------------------------------------------------------------------
           Name: RING_KEY.py
         Author: Daniele De Santis (desantis@areasx.com)
        Version: 1.0
  Last Modified: 05/02/07
    Description: Attiva un rel alla ricezione di un RING
                 
          Note : 
------------------------------------------------------------------------------
"""
# importo i built-in modules
import MDM
import MOD
import sys
import GPIO

IMPULSO=10 # 10 = 1sec

#Configurazione port di I/O
r=GPIO.setIOdir(1,0,0) #port 1  input
r=GPIO.setIOdir(8,0,0) #port 8  input
r=GPIO.setIOdir(2,0,1) #port 2  output
r=GPIO.setIOdir(6,0,1) #port 6  output
r=GPIO.setIOdir(7,0,1) #port 7  output

GSM_NUMBER={}
#Lista dei numeri GSM autorizzati (omettere il prefisso internazionale +39)
GSM_NUMBER[0]=("3478500000")
GSM_NUMBER[1]=("3389600000")

##########################################
#
#MAIN
#
##########################################
print "Test RING KEY"
#Check registrazione
while(1):
  res = MDM.send('AT+CGREG?\r',0)
  res = MDM.receive(20)
  if (res.find ('+CGREG: 0,1') != -1):
    print "Modem registrato!"
    s=GPIO.setIOvalue(2,0) #LED TEST OFF
    break
  s=GPIO.setIOvalue(2,1) #LED TEST ON
  MOD.sleep(10)
  s=GPIO.setIOvalue(2,0) #LED TEST OFF
  MOD.sleep(10)
  

#Abilita l'identificazione chiamante
res = MDM.send('AT+CLIP=1\r',0)
res = MDM.receive(20)
res = res.find ('OK')
if (res == -1):
  print 'ERROR no CLIP'
  sys.exit(0)
  
  
while(1):
  res = MDM.receive(20)
  if (res.find ('RING') != -1):
    tmp = res.split("\r\n") #cut \r\n
    MDM.send('ATH\r',0) #END CALL
    null=MDM.receive(10)
    if(len(tmp)>4):
      res=tmp[3] #CLIP
      tmp = res.split(" ") #cut " "
      if(len(tmp)>1):
        res = tmp[1].split(",")
        num=res[0].replace("\"", "") 
        if (res[1]=="145"):
          num=num[3:]
        print "Ring da %s" % num
        for i in range(0,len(GSM_NUMBER)):
          if(num==GSM_NUMBER[i]):
            print "AUTORIZZATO"
            s=GPIO.setIOvalue(6,1)
            MOD.sleep(IMPULSO)
            s=GPIO.setIOvalue(6,0)
            break